﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace upd_api_macro_test
{
    public partial class Form1 : Form
    {
        //macro number
        static public int macro_num;
        //macro function
        static public int[] macro_data_func = new int[define.MACRO_MAX];
        //macro parameter
        static public int[] macro_data_para = new int[define.MACRO_MAX];


        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
        }


        //printer select
        private void button7_Click(object sender, EventArgs e)
        {
            DialogResult ret;

            ret = printDialog1.ShowDialog();
            if (ret == System.Windows.Forms.DialogResult.OK)
            {
                textBox9.Text = printDialog1.PrinterSettings.PrinterName;
            }
        }


        //close
        private void button8_Click(object sender, EventArgs e)
        {
            Close();
        }


        //macro get
        private void button1_Click(object sender, EventArgs e)
        {
            int num = 0,i = 0;
            int[] data = new int[define.MACRO_MAX];
            string str;
            bool ret;

            if (textBox9.Text == "")
            {
                MessageBox.Show("The printer is not chosen.",
                                "Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                return;
            }
            comboBox2.Items.Clear();
            ret = UpdSdk.api.GetMacroData(textBox9.Text.Normalize(), comboBox1.SelectedIndex, ref num, ref data);
            if (ret == false)
            {
                MessageBox.Show("Extraction of a macro goes wrong.",
                                "Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                return;
            }
            if (num > define.MACRO_MAX)
            {
                macro_num = 0;
                return;
            }
            else
            {
                macro_num = num;
            }
            for (i = 0; i < macro_num; i++)
            {
                macro_data_func[i] = data[i] & 0xff;
                macro_data_para[i] = (data[i] >> 8) & 0xff;
                str = "Macro " + (i + 1).ToString();
                comboBox2.Items.Add(str);
            }
            comboBox2.Enabled = true;
            comboBox3.Enabled = true;
            textBox1.Enabled = true;

            button3.Enabled = true;
            button4.Enabled = true;
            button5.Enabled = true;

            if (comboBox2.Items.Count > 0)
            {
                comboBox2.SelectedIndex = 0;
            }
        }


        //macro set
        private void button2_Click_1(object sender, EventArgs e)
        {
            int[] data = new int[define.MACRO_MAX];
            int i;
            bool ret;


            if (textBox9.Text == "")
            {
                MessageBox.Show("The printer is not chosen.",
                                "Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                return;
            }
            for (i = 0; i < macro_num; i++)
            {
                data[i] = ((macro_data_para[i] & 0xff) << 8) | (macro_data_func[i] & 0xff);
            }
            ret = UpdSdk.api.SetMacroData(textBox9.Text.Normalize(), comboBox1.SelectedIndex, macro_num, data);
            if (ret == false)
            {
                MessageBox.Show("Extraction of a macro goes wrong.",
                                "Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error);
                return;
            }
        }


        //change
        private void button3_Click(object sender, EventArgs e)
        {
            int sel = comboBox2.SelectedIndex;

            macro_data_func[sel] = comboBox3.SelectedIndex;
            if ((macro_data_func[sel] == define.UPD_MACRO_FEED) ||
                (macro_data_func[sel] == define.UPD_MACRO_BACKFEED) ||
                (macro_data_func[sel] == define.UPD_MACRO_LEDBEZEL) ||
                (macro_data_func[sel] == define.UPD_MACRO_LOGOPRINT))
            {
                int dat = int.Parse(textBox1.Text);
                if (dat < 256)
                {
                    macro_data_para[sel] = dat;
                }
                else
                {
                    macro_data_para[sel] = 0;
                }
            }
            else if ((macro_data_func[sel] == define.UPD_MACRO_ANOTHER_CMD))
            {
                int dat = Convert.ToInt32(textBox1.Text, 16);
                if (dat < 256)
                {
                    macro_data_para[sel] = dat;
                }
                else
                {
                    macro_data_para[sel] = 0;
                }

            }
            else
            {
                macro_data_para[sel] = 0;
            }
        }


        //addition
        private void button4_Click(object sender, EventArgs e)
        {
            string str;

            if (macro_num >= (define.MACRO_MAX - 1))
            {
                return;
            }
            macro_data_func[macro_num] = comboBox3.SelectedIndex;

            if ((macro_data_func[macro_num] == define.UPD_MACRO_FEED) ||
                (macro_data_func[macro_num] == define.UPD_MACRO_BACKFEED) || 
                (macro_data_func[macro_num] == define.UPD_MACRO_LEDBEZEL) ||
                (macro_data_func[macro_num] == define.UPD_MACRO_LOGOPRINT))
            {
                int dat = int.Parse(textBox1.Text);
                if (dat < 256)
                {
                    macro_data_para[macro_num] = dat;
                }
                else
                {
                    macro_data_para[macro_num] = 0;
                }
            }
            else if ((macro_data_func[macro_num] == define.UPD_MACRO_ANOTHER_CMD))
            {
                int dat = Convert.ToInt32(textBox1.Text, 16);
                if (dat < 256)
                {
                    macro_data_para[macro_num] = dat;
                }
                else
                {
                    macro_data_para[macro_num] = 0;
                }

            }
            macro_num++;
            str = "Macro " + macro_num.ToString();
            comboBox2.Items.Add(str);
            if (comboBox2.Items.Count == 1)
            {
                comboBox2.SelectedIndex = 0;
            }
        }


        //delete
        private void button5_Click(object sender, EventArgs e)
        {
            if (macro_num < 0)
            {
                return;
            }
            macro_num--;
            comboBox2.Items.RemoveAt(comboBox2.Items.Count - 1);
        }


        //macro number select change
        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int sel = comboBox2.SelectedIndex;

            comboBox3.SelectedIndex = macro_data_func[sel];
            if (comboBox3.SelectedIndex == define.UPD_MACRO_ANOTHER_CMD)
            {
                textBox1.Text = macro_data_para[sel].ToString("X");
            }
            else
            {
                textBox1.Text = macro_data_para[sel].ToString();
            }
        }


        //key press only num input
        private void textBox_KeyPress(object sender,
        System.Windows.Forms.KeyPressEventArgs e)
        {
            if (comboBox3.SelectedIndex == define.UPD_MACRO_ANOTHER_CMD)
            {
                if ((!Char.IsDigit(e.KeyChar)) && ((e.KeyChar < 'a') || (e.KeyChar > 'f')) && ((e.KeyChar < 'A') || (e.KeyChar > 'F')) && (e.KeyChar != '\b'))
                {
                    e.Handled = true;
                }
            }
            else
            {
                if ((!Char.IsDigit(e.KeyChar)) && (e.KeyChar != '\b'))
                {
                    e.Handled = true;
                }
            }
        }


        //key press disable
        private void textBox_NoInputKeyPress(object sender,
        System.Windows.Forms.KeyPressEventArgs e)
        {
            e.KeyChar = (char)0x00;
        }


        //max length change
        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox3.SelectedIndex == define.UPD_MACRO_ANOTHER_CMD)
            {
                textBox1.MaxLength = 2;
            }
            else
            {
                textBox1.MaxLength = 3;
            }
            textBox1.Text = "";
        }
    }
}
