﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace upd_api_test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        //sdk version get
        private void button1_Click(object sender, EventArgs e)
        {
            int ver;

            ver = UpdSdk.api.GetApiVersion();
            textBox1.Text = ver.ToString();
        }

        
        //printer select
        private void button7_Click(object sender, EventArgs e)
        {
            DialogResult ret;

            ret = printDialog1.ShowDialog();
            if (ret == System.Windows.Forms.DialogResult.OK)
            {
                textBox5.Text = printDialog1.PrinterSettings.PrinterName;
                button1.Enabled = true;
                button2.Enabled = true;
                button4.Enabled = true;
                button5.Enabled = true;
                button6.Enabled = true;
            }
        }

        
        //raw data write
        private void button2_Click(object sender, EventArgs e)
        {
            //test print
            byte[] bin_data = { 0x1b, 0x21, 0x00,   //Normal character.
                                (byte)'0',(byte)'1',(byte)'2',(byte)'3',(byte)'4',(byte)'5',(byte)'6',(byte)'7',
                                (byte)'8',(byte)'9',
                                (byte)'A',(byte)'B',(byte)'C',(byte)'D',(byte)'E',(byte)'F',(byte)'G',(byte)'H',
                                (byte)'I',(byte)'J',(byte)'K',(byte)'L',(byte)'M',(byte)'N',(byte)'O',(byte)'P',
                                (byte)'Q',(byte)'R',(byte)'S',(byte)'T',(byte)'U',(byte)'V',(byte)'W',(byte)'X',
                                (byte)'Y',(byte)'Z',
                                0x0d,0x0a,
                                0x1b, 0x21, 0x10,   //Horizontal double character.
                                (byte)'0',(byte)'1',(byte)'2',(byte)'3',(byte)'4',(byte)'5',(byte)'6',(byte)'7',
                                (byte)'8',(byte)'9',
                                (byte)'A',(byte)'B',(byte)'C',(byte)'D',(byte)'E',(byte)'F',(byte)'G',(byte)'H',
                                (byte)'I',(byte)'J',(byte)'K',(byte)'L',(byte)'M',(byte)'N',(byte)'O',(byte)'P',
                                (byte)'Q',(byte)'R',(byte)'S',(byte)'T',(byte)'U',(byte)'V',(byte)'W',(byte)'X',
                                (byte)'Y',(byte)'Z',
                                0x0d,0x0a,
                                0x1b, 0x21, 0x20,   //Vertical double character.
                                (byte)'0',(byte)'1',(byte)'2',(byte)'3',(byte)'4',(byte)'5',(byte)'6',(byte)'7',
                                (byte)'8',(byte)'9',
                                (byte)'A',(byte)'B',(byte)'C',(byte)'D',(byte)'E',(byte)'F',(byte)'G',(byte)'H',
                                (byte)'I',(byte)'J',(byte)'K',(byte)'L',(byte)'M',(byte)'N',(byte)'O',(byte)'P',
                                (byte)'Q',(byte)'R',(byte)'S',(byte)'T',(byte)'U',(byte)'V',(byte)'W',(byte)'X',
                                (byte)'Y',(byte)'Z',
                                0x0d,0x0a,
                                0x1b, 0x4a, 0xa0,   //Feed.
                                0x1b, 0x69          //Full cut.
                              };

            if (textBox5.Text == "")
            {
                return;
            }
            UpdSdk.api.WriteRawData(textBox5.Text, bin_data, bin_data.Length);
        }


        //LM enable
        private void button5_Click(object sender, EventArgs e)
        {
            UpdSdk.api.EnableLM();
        }

        
        //LM disable
        private void button6_Click(object sender, EventArgs e)
        {
            UpdSdk.api.DisableLM();
        }
        
        
        //printer status get
        private void button4_Click(object sender, EventArgs e)
        {
            int status = 0;
            bool bRet;

            bRet = UpdSdk.api.GetPrinterStatus(textBox5.Text, ref status);
            if (bRet == false)
            {
                return;
            }

            if (status == define.UPD_STATUS_NORMAL)
            {
                textBox4.Text = "Normal";
            }
            else if (status == define.UPD_STATUS_DOOR_OPEN)
            {
                textBox4.Text = "Cover Open";
            }
            else if (status == define.UPD_STATUS_PAPER_END)
            {
                textBox4.Text = "Paper End";
            }
            else if (status == define.UPD_STATUS_NEAR_END)
            {
                textBox4.Text = "Paper Near End";
            }
            else if (status == define.UPD_STATUS_PAPER_FULL)
            {
                textBox4.Text = "Paper Detect";
            }
            else if (status == define.UPD_STATUS_OTHER_ERR)
            {
                textBox4.Text = "Other Errors";
            }
            else if (status == define.UPD_STATUS_PAPER_JAM)
            {
                textBox4.Text = "Paper Course Out";
            }
            else if (status == define.UPD_STATUS_OFFLINE)
            {
                textBox4.Text = "Printer Offline";
            }
        }


        //close
        private void button8_Click(object sender, EventArgs e)
        {
            Close();
        }
        
        
        //key press disable
        private void textBox_NoInputKeyPress(object sender,
        System.Windows.Forms.KeyPressEventArgs e)
        {
            e.KeyChar = (char)0x00;
        }

    }
}
